#include "boss.h"

#include "obj.h"
#include <list>
using namespace std;

BallMonster::BallMonster () {
	r = 100;
	x = 640 / 2 - r / 2;
	y = 0 + r / 2;

	ballBmp = new Bmp ( "gfx/ball.bmp" );

	for ( int i = 0; i < numBalls; i++ ) {
		balls . push_back ( new Ball ( x - r / 2 + rand () % r, y - r / 2 + rand () % r, ballBmp ) );
	}
}

BallMonster::~BallMonster () {
	delete ballBmp;
}

void BallMonster::run () {
	y += 1;
	for ( BallsIt it = balls . begin (); it != balls . end (); it++ ) {
		(*it) -> run ( x, y, r );
	}
}

void BallMonster::draw () {
	for ( BallsIt it = balls . begin (); it != balls . end (); it++ )
		(*it) -> draw ();
}



// Ball

BallMonster::Ball::Ball ( int x, int y, Bmp * bmp ) {
	Ball::x = x;
	Ball::y = y;
	Ball::bmp = bmp;

	speed = 1.5;
	angle = rand () % 360;
	z = rand () % numBalls;
}

void BallMonster::Ball::run ( int circX, int circY, int circR ) {
	if ( incrZ ) {
		if ( z >= numBalls ) {
			incrZ = false;
			z--;
		} else {
			z++;
		}
	} else {
		if ( z <= 0 ) {
			incrZ = true;
			z++;
		} else { 
			z--;
		}
	}

	const int dX = abs ( circX - x );
	const int dY = abs ( circY - y );
	if ( sqrt ( dX * dX + dY * dY ) <= circR ) {
		angle -= 180;
	} else {
		angle += 10 - rand () % 20;
	}

	x += speed * cos ( angle );
	y += speed * sin ( angle );
}

void BallMonster::Ball::draw () {
	bmp -> drawMask ( x, y );
}
