#ifndef HEAD_BOSS
#define HEAD_BOSS

#include "obj.h"
#include <list>

class Boss {

	public:

	virtual void run () = 0;
	virtual void draw () = 0;
};

class BallMonster : public Boss {

	private:

	int x, y, r;
	Bmp * ballBmp;

	protected:

	static const int numBalls = 250;

	class Ball {

		private:

		float x, y;
		float speed;
		int z;
		bool incrZ;
		int angle;
		Bmp * bmp;

		public:

		Ball ( int x, int y, Bmp * bmp );

		void run ( int x, int y, int r );
		void draw ();
	};
	typedef std::list <Ball *> Balls;
	typedef Balls::iterator BallsIt;
	Balls balls;

	friend class Ball;

	public:

	BallMonster ();
	~BallMonster ();

	void run ();
	void draw ();
};

#endif
