#ifndef HEAD_GEN
#define HEAD_GEN

#include <string>
#include <vector>
#include <utility>
#include <fstream>

void initGen ();

enum Dir { n, ne, e, se, s, sw, w, nw, nil };

std::string numToText ( int num );
int textToNum ( std::string text );

class Exception {

	private:

	std::string msg;

	public:

	Exception () { msg = "Unknown error."; }
	Exception ( std::string argMsg ) { msg = argMsg; }

	std::string what () { return msg; }
};

class NoArg : public Exception {};
std::pair <std::string, std::string> stripArgs ( std::string & line, char leftArg, char rightArg ) throw ( NoArg );

/*
template <class DataType>
void init2dVector ( std::vector <std::vector <DataType> > & vect, int dimX, int dimY ) {
	std::vector::iterator itMax = vect . begin ();
	for ( int i = 0; i < dimX; i++ )
		vect++;

	for ( std::vector::iterator it = vect . begin (); it < dimX; it++ )
		vect . push_back ( std::vector <DataType> ( dimY ) );
}
*/

class FileIn {

	private:

	static const char COMMENT = '#';

	std::string lineBuff;
	std::ifstream streamIn;

	bool fileOpen;
	bool eofFlag;

	public:

	class FileError {};
		class CouldNotOpen : public FileError {};
		class EmptyFile : public FileError {};
		class ReadPastEof : public FileError {};

	FileIn ( std::string file ) throw ( FileError );
	~FileIn ();

	inline bool eof () { return eofFlag; }
	std::string getLine () throw ( ReadPastEof );
};

class FileOut {};

#endif
