#ifndef GUI_HEAD
#define GUI_HEAD

#include "lib.h"
#include <string>

void initGui ();

class GuiBox {

	private:

	int x1, y1, x2, y2;
	Bmp boxBmp;

	public:

	GuiBox ( int x1, int y1, int x2, int y2 );
	virtual inline ~GuiBox () {};

	inline int retX1 () { return x1; }
	inline int retY1 () { return y1; }
	inline int retX2 () { return x2; }
	inline int retY2 () { return y2; }

	virtual inline void draw () { boxBmp . draw ( x1, y1 ); }
};

class VoxBox : GuiBox {

	private:

	std::string vox;
	int detW ( std::string text );
	int detH ( std::string text );

	public:

	VoxBox ( std::string text, int x, int y );

	void draw ();
};

class MsgBox : VoxBox {

	private:

	static const int MSGX;
	static const int MSGY;
	static const Lib_Key MSGKEY;

	public:

	MsgBox ( std::string text );
};

class TextBox : GuiBox {

	private:

	std::string text;

	public:

	TextBox ( std::string text, int x1, int y1, int x2, int y2 );

	void draw ();
};

#endif
