#include "boss.h"
#include "player.h"
#include "enemy.h"
#include "obj.h"
#include "img.h"
#include "gui.h"
#include "lib.h"
#include "gen.h"
#include <cstddef>
#include <cstdlib>
#include <string>

int main () {
	initGen ();
	initLib ();
	initGui ();


	try {
		player = new Player ();
	} catch ( Bmp::LoadError err ) {
		fatErrMsg ( "Error loading player bitmap.\n   " + err . what () );
	}
	objs . push_back ( player );


	Lib_Clr bkgdClr = createClr ( 0, 0, 0 );
	screenBmp -> clearToClr ( bkgdClr );

	BallMonster ballMonster;

	while ( ! keyboard -> press ( KEY_ESC ) ) {
		while ( ! logicDone () ) {
/*
			static int timeCntr = 0;
			timeCntr++;
			if ( timeCntr > 50 ) {
				try {
					objs . push_back ( new Enemy ( rand () % 640, - 29 ) );
				} catch ( Bmp::LoadError err ) {
					fatErrMsg ( "Could not load enemy bitmap.\n   " + err . what () );
				}
				timeCntr = 0;
			}
*/

			ballMonster . run ();
			for ( ObjsIt it = objs . begin (); it != objs . end (); it++ ) {
				(*it) -> run ();
				if ( (*it) -> retRm () ) {
					objs . erase ( it );
					it--;
				}
			}
		}

		screenBmp -> lock ();
		ballMonster . draw ();
		for ( ObjsIt it = objs . begin (); it != objs . end (); it++ )
			(*it) -> draw ();
		screenBmp -> unlock ();

		displayFPS ();

		drawScreen ();
		screenBmp -> clearToClr ( bkgdClr );
	}

	return EXIT_SUCCESS;
}
END_OF_MAIN ();
