#include "obj.h"

#include "img.h"
#include "lib.h"
#include "gen.h"
#include <string>
using namespace std;

Objs objs;

Obj::Obj ( string bmpFile, int x, int y ) {
	bmp = imgList [ bmpFile ];

	setX ( x );
	setY ( y );
	setRm ( false );
}

bool Obj::coll ( Dir dir, int depth ) {

	int newX = x1, newY = y1;

	switch ( dir ) {
		case n:
			newY -= depth;
		break; case e:
			newX += depth;
		break; case s:
			newY += depth;
		break; case w:
			newX -= depth;
		break; case nil:
			return false;
		break; default:
			fatErrMsg ( "Non-cardinal direction passed to Obj::coll ( Dir, int )." );
	}
			
	for ( ObjsIt it = objs . begin (); it != objs . end (); it++ )
		if ( ! ((*it) == this) )
			if ( bmp -> coll ( newX, newY, (*it) -> x1, (*it) -> y1, (*(*it) -> bmp )) )
				return true;
	return false;
}

void Obj::move ( Dir dir, int dist ) {
	switch ( dir ) {
		bool noCollN, noCollE, noCollS, noCollW;

		case n:
			if ( ! coll ( n, dist ) ) {
				setY ( y1 - dist );
			}
		break; case ne:
			noCollN = ! coll ( n, dist );
			noCollE = ! coll ( e, dist );
			if ( noCollN && noCollE ) {
				setX ( x1 + dist );
				setY ( y1 - dist );
			} else if ( noCollN ) {
				setY ( y1 - dist );
			} else if ( noCollE ) {
				setX ( x1 + dist );
			}
		break; case e:
			if ( ! coll ( e, dist ) ) {
				setX ( x1 + dist );
			}
		break; case se:
			noCollS = ! coll ( s, dist );
			noCollE = ! coll ( e, dist );
			if ( noCollS && noCollE ) {
				setX ( x1 + dist );
				setY ( y1 + dist );
			} else if ( noCollS ) {
				setY ( y1 + dist );
			} else if ( noCollE ) {
				setX ( x1 + dist );
			}
		break; case s:
			if ( ! coll ( s, dist ) ) {
				setY ( y1 + dist );
			}
		break; case sw:
			noCollS = ! coll ( s, dist );
			noCollW = ! coll ( w, dist );
			if ( noCollS && noCollW ) {
				setX ( x1 - dist );
				setY ( y1 + dist );
			} else if ( noCollS ) {
				setY ( y1 + dist );
			} else if ( noCollW ) {
				setX ( x1 - dist );
			}
		break; case w:
			if ( ! coll ( w, dist ) ) {
				setX ( x1 - dist );
			}
		break; case nw:
			noCollN = ! coll ( n, dist );
			noCollW = ! coll ( w, dist );
			if ( noCollN && noCollW ) {
				setX ( x1 - dist );
				setY ( y1 - dist );
			} else if ( noCollN ) {
				setY ( y1 - dist );
			} else if ( noCollW ) {
				setX ( x1 - dist );
			}
		break; case nil:
			; // do nothing
		break; default:
			fatErrMsg ( "Non-cardinal direction passed to Obj::move ( Dir, int )." );
	}
}

void Obj::run () {
}
