#ifndef OBJ_HEAD
#define OBJ_HEAD

#include "lib.h"
#include "gen.h"
#include <string>
#include <list>

class Obj;

typedef std::list <Obj *> Objs;
typedef Objs::iterator ObjsIt;
extern Objs objs;

class Obj {

	protected:

	int x1, y1, x2, y2;
	bool rm;
	Bmp * bmp;

	public:

	Obj ( std::string bmpFile, int x, int y );
	virtual ~Obj () { ; }

	inline int retX1 () { return x1; }
	inline int retY1 () { return y1; }
	inline int retX2 () { return x2; }
	inline int retY2 () { return y2; }

	inline void setX ( int x ) { x1 = x; x2 = x + bmp -> retW () - 1; }
	inline void setY ( int y ) { y1 = y; y2 = y + bmp -> retW () - 1; }

	inline int retRm () { return rm; }
	inline void setRm ( bool newRm ) { rm = newRm; }

	inline void draw () { bmp -> drawMask ( x1, y1 ); }
	inline void draw ( int x, int y ) { bmp -> drawMask ( x, y ); }

	bool pxlColl ( int offX, int offY, Obj * obj );

	bool coll ( Dir dir, int depth );

	void move ( Dir dir, int dist );

	virtual void run ();
};

#endif
